{% extends 'base.html.twig' %}

{% block title %}Statistiques{% endblock %}

{% block body %}

    <h1 class="text-center fw-bold">{{ question.titreQuestion }}</h1>
    <div class="text-center border border-dark beauBlanc w-50 mx-auto m-5 p-2 rounded">
        <h2>Créer une statistique</h2>
        {% include 'controleur_statistiques/choix.html.twig' with {'question': question} %}
    </div>

    <div class="m-4">
        <h2 class="m-4">Liste des statistiques associées à la question que vous avez crée</h2>
            <div class="mx-auto w-75">
                {% if statistiques is not empty %}
                    {% for stat in statistiques %}
                         {% if stat["donnees"] is iterable %}
                        <canvas class="bg-light mt-4" id="myChart-{{ loop.index }}"></canvas>
                        <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
                        <script>
                            function generateRandomColor(){
                                let maxVal = 0xFFFFFF; // 16777215
                                let randomNumber = Math.random() * maxVal;
                                randomNumber = Math.floor(randomNumber);
                                randomNumber = randomNumber.toString(16);
                                let randColor = randomNumber.padStart(6, 0);
                                return `#${randColor.toUpperCase()}`
                            }
                            var colors = [];
                            for (let i = 0; i < {{ stat["donnees"]|length }}; i++) {
                                colors.push(generateRandomColor());
                            }

                            var ctx = document.getElementById('myChart-{{ loop.index }}').getContext('2d');
                            var data = {
                                labels: {{ stat["donnees"].abcisse | json_encode | raw }},
                                datasets: [{
                                    label: {{ stat["donnees"].ordonnees | json_encode | raw }},
                                    backgroundColor: colors,
                                    borderColor: 'rgba(255, 99, 132, 1)',
                                    borderWidth: 1,
                                    data: {{ stat["donnees"].valeur | json_encode | raw }}
                                }]
                            };
                            var options = {
                                scales: {
                                    yAxes: [{
                                        ticks: {
                                            beginAtZero: true
                                        }
                                    }]
                                }
                            };
                            var options = {
                                responsive:true
                            }
                            var myChart = new Chart(ctx, {
                                type: 'bar',
                                data: data,
                                options: options
                            });
                        </script>
                    {% else %}
                        <p>Stats valeur simple : {{ stat['donnees'] }}</p>
                    {% endif %}
                        {% endfor %}
                    {% else %}
                        <p>Vous n'avez pas encore enregistré de statistiques</p>
                    {% endif %}



                    {#    <a href="{{ path('app_statistiques_edit', {'id': question.getSondage().getId()}) }}">edit</a>#}
                    {#    <a href="{{ path('app_statistiques_edit', {'id': question.getSondage().getId()}) }}">edit</a>#}

                </div>
            </div>

        <a class="btn btn-secondary d-grid gap-2 col-2 mx-auto" href="{{ path('app_controleur_sondage_show', {"id": question.getSondage().getId()}) }}">Retour</a>
{% endblock %}
